// Auto-generated. Do not edit!

// (in-package rc_silhouettematch_client.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ObjectToDetect = require('../msg/ObjectToDetect.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let Instance = require('../msg/Instance.js');
let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class DetectObjectRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.object_to_detect = null;
      this.offset = null;
      this.pose_frame = null;
      this.robot_pose = null;
    }
    else {
      if (initObj.hasOwnProperty('object_to_detect')) {
        this.object_to_detect = initObj.object_to_detect
      }
      else {
        this.object_to_detect = new ObjectToDetect();
      }
      if (initObj.hasOwnProperty('offset')) {
        this.offset = initObj.offset
      }
      else {
        this.offset = 0.0;
      }
      if (initObj.hasOwnProperty('pose_frame')) {
        this.pose_frame = initObj.pose_frame
      }
      else {
        this.pose_frame = '';
      }
      if (initObj.hasOwnProperty('robot_pose')) {
        this.robot_pose = initObj.robot_pose
      }
      else {
        this.robot_pose = new geometry_msgs.msg.Pose();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DetectObjectRequest
    // Serialize message field [object_to_detect]
    bufferOffset = ObjectToDetect.serialize(obj.object_to_detect, buffer, bufferOffset);
    // Serialize message field [offset]
    bufferOffset = _serializer.float64(obj.offset, buffer, bufferOffset);
    // Serialize message field [pose_frame]
    bufferOffset = _serializer.string(obj.pose_frame, buffer, bufferOffset);
    // Serialize message field [robot_pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.robot_pose, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DetectObjectRequest
    let len;
    let data = new DetectObjectRequest(null);
    // Deserialize message field [object_to_detect]
    data.object_to_detect = ObjectToDetect.deserialize(buffer, bufferOffset);
    // Deserialize message field [offset]
    data.offset = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [pose_frame]
    data.pose_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [robot_pose]
    data.robot_pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += ObjectToDetect.getMessageSize(object.object_to_detect);
    length += _getByteLength(object.pose_frame);
    return length + 68;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_silhouettematch_client/DetectObjectRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ce26c836ab819b0aff79e1e7de9d9a09';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Description: Triggers detection of an object.
    
    # Required. Object that is to be detected
    ObjectToDetect object_to_detect
    
    # Optional. Shift in meters that will be applied to the calibrated base-plane
    float64 offset
    
    # Required. Pose frame for output poses (valid values are camera and external)
    string pose_frame
    
    # Required only if reference frame = external and sensor is robot-mounted
    geometry_msgs/Pose robot_pose
    
    
    ================================================================================
    MSG: rc_silhouettematch_client/ObjectToDetect
    # ID of the object
    string object_id
    
    # ROI in which to detect the object
    string region_of_interest_2d_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DetectObjectRequest(null);
    if (msg.object_to_detect !== undefined) {
      resolved.object_to_detect = ObjectToDetect.Resolve(msg.object_to_detect)
    }
    else {
      resolved.object_to_detect = new ObjectToDetect()
    }

    if (msg.offset !== undefined) {
      resolved.offset = msg.offset;
    }
    else {
      resolved.offset = 0.0
    }

    if (msg.pose_frame !== undefined) {
      resolved.pose_frame = msg.pose_frame;
    }
    else {
      resolved.pose_frame = ''
    }

    if (msg.robot_pose !== undefined) {
      resolved.robot_pose = geometry_msgs.msg.Pose.Resolve(msg.robot_pose)
    }
    else {
      resolved.robot_pose = new geometry_msgs.msg.Pose()
    }

    return resolved;
    }
};

class DetectObjectResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.object_id = null;
      this.instances = null;
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('object_id')) {
        this.object_id = initObj.object_id
      }
      else {
        this.object_id = '';
      }
      if (initObj.hasOwnProperty('instances')) {
        this.instances = initObj.instances
      }
      else {
        this.instances = [];
      }
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DetectObjectResponse
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [object_id]
    bufferOffset = _serializer.string(obj.object_id, buffer, bufferOffset);
    // Serialize message field [instances]
    // Serialize the length for message field [instances]
    bufferOffset = _serializer.uint32(obj.instances.length, buffer, bufferOffset);
    obj.instances.forEach((val) => {
      bufferOffset = Instance.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DetectObjectResponse
    let len;
    let data = new DetectObjectResponse(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [object_id]
    data.object_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [instances]
    // Deserialize array length for message field [instances]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.instances = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.instances[i] = Instance.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.object_id);
    object.instances.forEach((val) => {
      length += Instance.getMessageSize(val);
    });
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length + 16;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_silhouettematch_client/DetectObjectResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ec128204e3693d200db7f4bb38cba50d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    time timestamp
    
    string object_id
    
    # List of detected instances of the object
    Instance[] instances
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_silhouettematch_client/Instance
    time timestamp
    string id
    string object_id
    string pose_frame
    geometry_msgs/Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DetectObjectResponse(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.object_id !== undefined) {
      resolved.object_id = msg.object_id;
    }
    else {
      resolved.object_id = ''
    }

    if (msg.instances !== undefined) {
      resolved.instances = new Array(msg.instances.length);
      for (let i = 0; i < resolved.instances.length; ++i) {
        resolved.instances[i] = Instance.Resolve(msg.instances[i]);
      }
    }
    else {
      resolved.instances = []
    }

    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: DetectObjectRequest,
  Response: DetectObjectResponse,
  md5sum() { return 'dcf7721430b95212097251ccd643fc94'; },
  datatype() { return 'rc_silhouettematch_client/DetectObject'; }
};
